/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id: MetadataItemHolderMock.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.metadata.viewer.test;

import it.tidalwave.beans.FastBeanProperty;
import java.util.Date;
import it.tidalwave.metadata.MetadataItemHolder;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: MetadataItemHolderMock.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
public class MetadataItemHolderMock<Item> extends MetadataItemHolder<Item>
  {
    public MetadataItemHolderMock (final Item bean)
      {
        super(bean);
      }

    public MetadataItemHolderMock (final Item bean, final String sourceName, final String origin, final Date latestModificationTime)
      {
        super(bean, sourceName, origin, latestModificationTime);
      }

    @Override
    public boolean isAvailable()
      {
        FastBeanProperty available = FastBeanProperty.create("available");

        if (!available.isReadable(get())) // in a couple of tests we put arbitrary classes here
          {
            return true;
          }

        return (Boolean)available.getValue(get());
      }
  }
